> For the complete documentation index, see [llms.txt](https://docs.zama.org/concrete/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/concrete/get-started/terminology.md).

# Terminology

This document provides clear definitions of key concepts used in **Concrete** framework.

**Computation graph**

A data structure to represent a computation. It takes the form of a directed acyclic graph where nodes represent inputs, constants, or operations.

**Tracing**

A method that takes a Python function provided by the user and generates a corresponding computation graph.

**Bounds**

The minimum and the maximum value that each node in the computation graph can take. Bounds are used to determine the appropriate data type (for example, uint3 or int5) for each node before the computation graphs are converted to MLIR. **Concrete** simulates the graph with the inputs in the inputset to record the minimum and the maximum value for each node.

**Circuit**

The result of compilation. A circuit includes both client and server components. It has methods for various operations, such as printing and evaluation.

**Table Lookup (TLU)**

TLU stands for instructions in the form of y = T\[i]. In FHE, this operation is performed with Programmable Bootstrapping, which is the equivalent operation on encrypted values. To learn more about TLU, refer to the [Table Lookup basic](/concrete/operations/table_lookups.md) and tge [Table Lookup advanced](/concrete/explanations/advanced-features/table_lookups_advanced.md) section.

**Programmable Bootstrapping (PBS)**

PBS is equivalent to table lookup `y = T[i]` on encrypted values, which means that the inputs `i` and the outputs `y` are encrypted, but the table `T` is not encrypted. You can find a more detailed explanation in the [FHE Overview](/concrete/explanations/fhe_basics.md#noise-and-bootstrap).

**TFHE**

TFHE is a Fully Homomorphic Encryption (FHE) scheme that allows you to perform computations over encrypted data. For in-depth explanation of the TFHE scheme, read our blog post series [TFHE Deep Dive](https://www.zama.ai/post/tfhe-deep-dive-part-1).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zama.org/concrete/get-started/terminology.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
